module Main where

import Properties

import TestFeat
import Test.Feat
import Poly
import Unbound.LocallyNameless

-- experiment check: written in this way, the enumeration seems to not leak memory,
--                   however, it is also way slower than featCheck
myCheck :: Enumerable a => Int -> (a -> Bool) -> IO (Maybe a)
myCheck sizeLimit pred = do putStrLn $ "Testing at size 1"
                            loop 1 (lastTermAt 1)
  where loop p 0 | p < sizeLimit-1 = do putStrLn $ "Testing at size " ++ show (p+1)
                                        loop (p+1) (lastTermAt (p+1))
                 | otherwise = return Nothing
        loop p i | not (pred (select p i)) = return $ Just (select p i)
                 | otherwise = loop p (i-1)
        lastTermAt size = (fst $ (values :: [(Integer,[Exp])]) !! size) - 1

main = do
  myCheck 7 preservationCheck
  --featCheck 7 preservationCheck
