{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE DeriveDataTypeable #-}

module TestFeat where

import Poly

import Unbound.LocallyNameless

import Test.Feat
import Test.Feat.Enumerate hiding (Const)

instance Enumerable (Name Exp) where
  enumerate = nullary (s2n "x")

instance Enumerable (Bind (Name Exp) Exp) where
  enumerate = unary (funcurry bind)

instance Enumerable (Embed Exp) where
  enumerate = unary embed

instance Enumerable (Bind (Name Exp, Embed Exp) Exp) where
  enumerate = unary (funcurry bind)

instance Enumerable Exp where
  enumerate =  pay (nullary Unit)
            <> pay (nullary (Const 0))
            <> pay (unary Var)
            <> pay (unary Lam)
            <> pay (unary (funcurry App))
            <> pay (unary Let)
            <> pay (unary Ref)
            <> pay (unary Deref)
            <> pay (unary (funcurry Seq))
            <> pay (unary (funcurry Assign))
