{-# LANGUAGE MultiParamTypeClasses
           , TemplateHaskell
           , ScopedTypeVariables
           , FlexibleInstances
           , FlexibleContexts
           , UndecidableInstances
           , StandaloneDeriving
 #-}

module TestLazySearch where

import Poly
import Eval
import Typing
import Properties

import Data.Coolean hiding (Seq)
import Control.Search hiding (Const, Seq)

import Unbound.LocallyNameless

import qualified Data.Map as Map

deriving instance Typeable a => Typeable (Name a)

instance Enumerable (Name Exp) where
  enumerate = share (c0 (s2n "x"))

instance Enumerable (Bind (Name Exp) Exp) where
  enumerate = share (c2 bind)

instance Enumerable (Embed Exp) where
  enumerate = share (c1 embed)

instance Enumerable (Bind (Name Exp, Embed Exp) Exp) where
  enumerate = share (c2 bind)

instance Enumerable Exp where
  enumerate = datatype [
    c0 Unit,
    c0 (Const 0),
    c1 Var,
    c1 Lam,
    c2 App,
    c1 Let,
    c1 Ref,
    c1 Deref,
    c2 Seq,
    c2 Assign]

prop_preservationWithEval e =
  (toCool $ wellTyped e) !=> preservationCheck e

prop_preservationWithEval' e =
  (toCool $ wellTyped e) ==> preservationCheck e

prop_preservationWithEval'' e =
  (toCool $ wellTyped e) !&& (toCool $ canStep e Map.empty) !=> preservationCheck e

prop_preservationWithEval''' e =
  toCool $ preservationCheck e
